<template>
   <v-card outlined elevation="0">
      <v-card-subtitle>Классы/Группы</v-card-subtitle>
      <v-card-actions>
        <add-group @add="saveGroups" />
      </v-card-actions>
      <div class="d-flex flex-wrap pa-4">
        <v-sheet v-for="(group, i) in groups" :key="i" class="ma-1 pl-3 grey darken-3">
          <span class="subtitle-2 white--text">{{ group }}</span>
          <v-btn icon class="ma-0">
            <v-icon @click="openDelete(group)">mdi-close</v-icon>
          </v-btn>
        </v-sheet>
      </div>
      <v-dialog
        v-model="deleteDialog"
        max-width="400"
      >
        <v-card>
          <v-card-title>Удалить "{{ groupForDelete }}?"</v-card-title>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="green darken-1"
              text
              @click="closeDelete"
            >
              Отмена
            </v-btn>
            <v-btn
              color="green darken-1"
              text
              @click="deleteGroup"
            >
              Удалить
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-card>
</template>

<script>
import { mapState } from 'vuex';
import api from '@/api';
import AddGroup from '@/components/profile/AddGroup';

export default {
  name: 'TeacherGroups',
  components: {
    AddGroup
  },
  data() {
    return {
      groups: [],
      deleteDialog: false,
      groupForDelete: ''
    }
  },
  computed: {
    ...mapState('user', ['_id']),
  },
  created() {
    this.getGroups();
  },
  methods: {
    async saveGroups(group) {
      this.groups.push(group);
      await api.teacher.saveGroups({ groups: this.groups });
      await this.getGroups();
    },
    async getGroups() {
      const res = await api.teacher.getGroups();
      this.groups = res.answer;
    },
    openDelete(group) {
      this.groupForDelete = group;
      this.deleteDialog = true;
    },
    closeDelete() {
      this.groupForDelete = '';
      this.deleteDialog = false;
    },
    async deleteGroup() {
      this.groups = this.groups.filter(g => g !== this.groupForDelete);
      await api.teacher.saveGroups({ groups: this.groups });
      await this.getGroups();
      this.groupForDelete = '';
      this.deleteDialog = false;
    }
  }
}
</script>